package org.amse.mARICa.game;

import org.amse.mARICa.model.ESeatPlayer;
import org.amse.mARICa.model.IBoard;
import org.amse.mARICa.model.IPlayer;

/**
 *   ,   
 *   
 * @author mARICa
 */
public interface IGame {

	/**
	 *        
	 * @return true -       
	 *   -      -  
	 *     
	 */
	boolean isWin();
	/**
	 * @return  
	 */
	IPlayer getCurrentPlayer();
	/**
	 * @param player
	 * @return  
	 */
	ESeatPlayer getSeatPlayer(IPlayer player);
	
	/**
	 *      k- 
	 * @param k -     0..
	 * @return true -  
	 */
	boolean canChoose(int k);
	/**
	 *       k.
	 *  ,       
	 * @param k -     0..
	 * @return true -       
	 */
	//boolean choose (int k);
	/**
	 * @return 
	 */
	IBoard getBoard();
	
	/**
	 * get  set   
	 */
	
	public IPlayer getPlayer1();
	public void setPlayer1(IPlayer myPlayer1);

	public IPlayer getPlayer2();
	public void setPlayer2(IPlayer myPlayer2); 
	
	/**
	 *      
	 * @param o
	 */
	void addListener(IGameListener o);
	boolean removeListener(IGameListener o);
	
	EKindWins getWiner();
	
	void setIsGameNow(boolean isGameNow);
	/**
	 *    
	 */
	void reverseSeatPlayer();
}
