package org.amse.mARICa.model;

import java.util.List;
import org.amse.mARICa.model.impl.Move;

/**
 *   
 *      
 *    -     
 *   . 
 * @author mARICa
 *
 */
public interface IBoard extends Cloneable{

	/**
	 * @return -    
	 */
	int getCountPots();
	/**
	 * @return -    
	 */
	int getCountAllPots();
	/**
	 * @return  -    
	 */
	int getCountBeans();
	/**
	 *  - ,       ,
	 *   ,    
	 * @param countBeans
	 */
	void setCountBeans(int countBeans);
	/**
	 * @param k -  
	 * @return    
	 *         -1 -       
	 */
	int getCountInPot(int k);
	/**
	 * @return -    1
	 */
	int getCountInKalah1();
	/**
	 * @return -    2
	 */
	int getCountInKalah2();
	/**
	 *    - -    
	 * @return      
	 */
	int[] getState();
	
	/**
	 *  .  0   -   
	 *   -  ,      
	 * @return   ,   
	 */
	List<Move> getMoves();
	/**
	 *   player  k- 
	 * @param player -    
	 * @param k -     0..
	 * @return true -  
	 */
	boolean canChoose(ESeatPlayer player, int k);
	/**
	 * player     k
	 * @param player -    
	 * @param k -     0..
	 * @return true -       
	 */
	boolean choose (ESeatPlayer player, int k);
	/**
	 *   
	 */
	void logBoard();
	
	Object clone();
	
	/**
	 *   -      
	 * @return
	 */
	boolean isFinishGame();

}
