package org.amse.mARICa.model;

import org.amse.mARICa.model.impl.BantumiException;

/**
 *   
 *  ,   ( EventThread),   
 *     .    getMove() ,
 *     ""    . 
 *      ,      ,
 * -  isReady(),   -     getChoose()
 *        .
 *     Game,      ,
 *     .
 * ,    .     .
 * @author mARICa
 *
 */
public interface IPlayer {
	/**
	 *   
	 * @param kind
	 */
	void setKindPlayer(EKindPlayer kind);
	/**
	 * @return  
	 */
	EKindPlayer getKindPlayer();
	/**
	 *     -  ""   
	 * @throws BantumiException 
	 */
	void getMove() throws BantumiException;
	/**
	 *        
	 * @param b
	 */
	void setReady(boolean b);
	/**
	 * @return      
	 */	
	boolean isReady();
	/**
	 *       
	 * @param b
	 */
	void setCurrent(boolean b);
	/**
	 * @return    
	 */
	boolean isCurent();
	/**
	 * @return   
	 */
	int getChoose();
	/**
	 *    (  )
	 *   Game,     
	 */
	void setSeat(ESeatPlayer seat);
	/**
	 * @return   -   
	 */
	ESeatPlayer getSeat();

	/**
	 *   ,   
	 * @param pot  
	 */
	void setChoose(int pot);
	/**
	 *    , 
	 * ,     stop
	 *    (  ) 
	 * @throws BantumiException 
	 */
	void setStopGame(boolean stopGame) throws BantumiException;
	/**
	 * @return    
	 */
	boolean getStopGame();
	
	/**
	 *     
	 */
	void reverseSeat();


}
