package org.amse.mARICa.model.impl.players;

import org.amse.mARICa.game.IGame;
import org.amse.mARICa.model.EKindPlayer;
import org.amse.mARICa.model.ESeatPlayer;
import org.amse.mARICa.model.IPlayer;
import org.amse.mARICa.model.impl.BantumiException;

public class AbstractPlayer implements IPlayer {
	
	protected boolean myIsCurrent;
	protected IGame myGame;
	protected boolean myIsReady;
	protected ESeatPlayer mySeat;	
	protected int myChoosingPot = -1;
	protected EKindPlayer myKind;
	protected boolean myStopGame;

	protected AbstractPlayer(EKindPlayer kind, IGame game){
		myIsCurrent = false;
		myIsReady = false;
		myStopGame = false;
		myKind = kind;
		myGame = game;
	}
	public void setReady(boolean b){
		myIsReady = b;
	}
	
	public boolean isReady() {
		return myIsReady;
	}
	
	public void setCurrent(boolean b){
		myIsCurrent = b;
	}
	
	public boolean isCurent(){
		return myIsCurrent;
	}

	public EKindPlayer getKindPlayer() {
		return myKind;
	}
	
	public void setKindPlayer(EKindPlayer kind) {
		myKind = kind;	
	}

	public ESeatPlayer getSeat() {
		return mySeat;
	}
	
	public void setSeat(ESeatPlayer seat) {
		mySeat = seat;
	}
	
	public void reverseSeat() {
		if (mySeat == ESeatPlayer.UP){
			mySeat = ESeatPlayer.DOWN;
		}else{
			mySeat = ESeatPlayer.UP;
		}	
	}

	public boolean getStopGame() {
		return myStopGame;
	}
	
	/**
	 *   
	 */
	public void getMove() throws BantumiException {
		
	}
	
	public int getChoose() {
		myIsReady = false;
		return myChoosingPot;
	}

	public void setChoose(int pot) {}	

	public void setStopGame(boolean stopGame) throws BantumiException {
		myStopGame = stopGame;
	}

}
